<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Features.Nominal</span><span>
</span><span id="line-2"></span><span>  </span><span class="hs-special">(</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier">NF</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-3"></span><span>    </span><span class="annot"><a href="Features.Nominal.html#copyNF"><span class="hs-identifier">copyNF</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-4"></span><span>    </span><span class="annot"><a href="Features.Nominal.html#personNumber"><span class="hs-identifier">personNumber</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-5"></span><span>    </span><span class="annot"><a href="Features.Nominal.html#Person"><span class="hs-identifier">Person</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-6"></span><span>    </span><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier">Number</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-7"></span><span>    </span><span class="annot"><a href="Features.Nominal.html#Case"><span class="hs-identifier">Case</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-8"></span><span>    </span><span class="annot"><a href="Features.Nominal.html#Determiner"><span class="hs-identifier">Determiner</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-9"></span><span>    </span><span class="annot"><a href="Features.Nominal.html#Possessive"><span class="hs-identifier">Possessive</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-10"></span><span>  </span><span class="hs-special">)</span><span>
</span><span id="line-11"></span><span class="hs-keyword">where</span><span>
</span><span id="line-12"></span><span>
</span><span id="line-13"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.Adverbial.html"><span class="hs-identifier">Features.Adverbial</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Features.Adverbial.html#Distance"><span class="hs-identifier">Distance</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-14"></span><span>
</span><span id="line-15"></span><span class="hs-comment">-- | Nominal feature complex used</span><span>
</span><span id="line-16"></span><span class="hs-keyword">data</span><span> </span><span id="NF"><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-var">NF</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span id="NF"><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-var">NF</span></a></span></span><span>
</span><span id="line-17"></span><span>  </span><span class="hs-special">{</span><span> </span><span id="person"><span class="annot"><span class="annottext">NF -&gt; Person
</span><a href="Features.Nominal.html#person"><span class="hs-identifier hs-var hs-var">person</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#Person"><span class="hs-identifier hs-type">Person</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-18"></span><span>    </span><span id="number"><span class="annot"><span class="annottext">NF -&gt; Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var hs-var">number</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier hs-type">Number</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-19"></span><span>    </span><span id="grammCase"><span class="annot"><span class="annottext">NF -&gt; Case
</span><a href="Features.Nominal.html#grammCase"><span class="hs-identifier hs-var hs-var">grammCase</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#Case"><span class="hs-identifier hs-type">Case</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-20"></span><span>    </span><span id="possessive"><span class="annot"><span class="annottext">NF -&gt; Possessive
</span><a href="Features.Nominal.html#possessive"><span class="hs-identifier hs-var hs-var">possessive</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#Possessive"><span class="hs-identifier hs-type">Possessive</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-21"></span><span>    </span><span id="determiner"><span class="annot"><span class="annottext">NF -&gt; Determiner
</span><a href="Features.Nominal.html#determiner"><span class="hs-identifier hs-var hs-var">determiner</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#Determiner"><span class="hs-identifier hs-type">Determiner</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-22"></span><span>    </span><span id="coord"><span class="annot"><span class="annottext">NF -&gt; Bool
</span><a href="Features.Nominal.html#coord"><span class="hs-identifier hs-var hs-var">coord</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Bool</span></span><span>
</span><span id="line-23"></span><span>  </span><span class="hs-special">}</span><span>
</span><span id="line-24"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081463"><span id="local-6989586621679081465"><span id="local-6989586621679081467"><span class="annot"><span class="annottext">Int -&gt; NF -&gt; ShowS
[NF] -&gt; ShowS
NF -&gt; String
(Int -&gt; NF -&gt; ShowS)
-&gt; (NF -&gt; String) -&gt; ([NF] -&gt; ShowS) -&gt; Show NF
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [NF] -&gt; ShowS
$cshowList :: [NF] -&gt; ShowS
show :: NF -&gt; String
$cshow :: NF -&gt; String
showsPrec :: Int -&gt; NF -&gt; ShowS
$cshowsPrec :: Int -&gt; NF -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081458"><span id="local-6989586621679081460"><span class="annot"><span class="annottext">NF -&gt; NF -&gt; Bool
(NF -&gt; NF -&gt; Bool) -&gt; (NF -&gt; NF -&gt; Bool) -&gt; Eq NF
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: NF -&gt; NF -&gt; Bool
$c/= :: NF -&gt; NF -&gt; Bool
== :: NF -&gt; NF -&gt; Bool
$c== :: NF -&gt; NF -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-25"></span><span>
</span><span id="line-26"></span><span class="hs-comment">-- | Copy Person and Number from source NF to target NF</span><span>
</span><span id="line-27"></span><span class="annot"><a href="Features.Nominal.html#copyNF"><span class="hs-identifier hs-type">copyNF</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span>
</span><span id="line-28"></span><span id="copyNF"><span class="annot"><span class="annottext">copyNF :: NF -&gt; NF -&gt; NF
</span><a href="Features.Nominal.html#copyNF"><span class="hs-identifier hs-var hs-var">copyNF</span></a></span></span><span> </span><span id="local-6989586621679081456"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081456"><span class="hs-identifier hs-var">srcF</span></a></span></span><span> </span><span id="local-6989586621679081455"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081455"><span class="hs-identifier hs-var">tgtF</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-29"></span><span>  </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081455"><span class="hs-identifier hs-var">tgtF</span></a></span><span>
</span><span id="line-30"></span><span>    </span><span class="hs-special">{</span><span> </span><span class="annot"><span class="annottext">person :: Person
</span><a href="Features.Nominal.html#person"><span class="hs-identifier hs-var">person</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NF -&gt; Person
</span><a href="Features.Nominal.html#person"><span class="hs-identifier hs-var hs-var">person</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081456"><span class="hs-identifier hs-var">srcF</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-31"></span><span>      </span><span class="annot"><span class="annottext">number :: Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var">number</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NF -&gt; Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var hs-var">number</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081456"><span class="hs-identifier hs-var">srcF</span></a></span><span>
</span><span id="line-32"></span><span>    </span><span class="hs-special">}</span><span>
</span><span id="line-33"></span><span>
</span><span id="line-34"></span><span class="hs-comment">-- | Extract Person and Number from NF</span><span>
</span><span id="line-35"></span><span class="annot"><a href="Features.Nominal.html#personNumber"><span class="hs-identifier hs-type">personNumber</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Features.Nominal.html#Person"><span class="hs-identifier hs-type">Person</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier hs-type">Number</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-36"></span><span id="personNumber"><span class="annot"><span class="annottext">personNumber :: NF -&gt; (Person, Number)
</span><a href="Features.Nominal.html#personNumber"><span class="hs-identifier hs-var hs-var">personNumber</span></a></span></span><span> </span><span id="local-6989586621679081454"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081454"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF -&gt; Person
</span><a href="Features.Nominal.html#person"><span class="hs-identifier hs-var hs-var">person</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081454"><span class="hs-identifier hs-var">nf</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">NF -&gt; Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var hs-var">number</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081454"><span class="hs-identifier hs-var">nf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-37"></span><span>
</span><span id="line-38"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-39"></span><span class="hs-comment">-- Basic nominal features</span><span>
</span><span id="line-40"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-41"></span><span>
</span><span id="line-42"></span><span class="hs-keyword">data</span><span> </span><span id="Person"><span class="annot"><a href="Features.Nominal.html#Person"><span class="hs-identifier hs-var">Person</span></a></span></span><span>
</span><span id="line-43"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="First"><span class="annot"><a href="Features.Nominal.html#First"><span class="hs-identifier hs-var">First</span></a></span></span><span>
</span><span id="line-44"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Second"><span class="annot"><a href="Features.Nominal.html#Second"><span class="hs-identifier hs-var">Second</span></a></span></span><span>
</span><span id="line-45"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Third"><span class="annot"><a href="Features.Nominal.html#Third"><span class="hs-identifier hs-var">Third</span></a></span></span><span>
</span><span id="line-46"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081445"><span id="local-6989586621679081447"><span id="local-6989586621679081449"><span class="annot"><span class="annottext">Int -&gt; Person -&gt; ShowS
[Person] -&gt; ShowS
Person -&gt; String
(Int -&gt; Person -&gt; ShowS)
-&gt; (Person -&gt; String) -&gt; ([Person] -&gt; ShowS) -&gt; Show Person
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Person] -&gt; ShowS
$cshowList :: [Person] -&gt; ShowS
show :: Person -&gt; String
$cshow :: Person -&gt; String
showsPrec :: Int -&gt; Person -&gt; ShowS
$cshowsPrec :: Int -&gt; Person -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081441"><span id="local-6989586621679081443"><span class="annot"><span class="annottext">Person -&gt; Person -&gt; Bool
(Person -&gt; Person -&gt; Bool)
-&gt; (Person -&gt; Person -&gt; Bool) -&gt; Eq Person
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: Person -&gt; Person -&gt; Bool
$c/= :: Person -&gt; Person -&gt; Bool
== :: Person -&gt; Person -&gt; Bool
$c== :: Person -&gt; Person -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-47"></span><span>
</span><span id="line-48"></span><span class="hs-comment">-- | The feature Zero is necessary to have mempty on monoids.</span><span>
</span><span id="line-49"></span><span class="hs-keyword">data</span><span> </span><span id="Number"><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier hs-var">Number</span></a></span></span><span>
</span><span id="line-50"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="Singular"><span class="annot"><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span></span><span>
</span><span id="line-51"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Plural"><span class="annot"><a href="Features.Nominal.html#Plural"><span class="hs-identifier hs-var">Plural</span></a></span></span><span>
</span><span id="line-52"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Zero"><span class="annot"><a href="Features.Nominal.html#Zero"><span class="hs-identifier hs-var">Zero</span></a></span></span><span>
</span><span id="line-53"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081432"><span id="local-6989586621679081434"><span id="local-6989586621679081436"><span class="annot"><span class="annottext">Int -&gt; Number -&gt; ShowS
[Number] -&gt; ShowS
Number -&gt; String
(Int -&gt; Number -&gt; ShowS)
-&gt; (Number -&gt; String) -&gt; ([Number] -&gt; ShowS) -&gt; Show Number
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Number] -&gt; ShowS
$cshowList :: [Number] -&gt; ShowS
show :: Number -&gt; String
$cshow :: Number -&gt; String
showsPrec :: Int -&gt; Number -&gt; ShowS
$cshowsPrec :: Int -&gt; Number -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081428"><span id="local-6989586621679081430"><span class="annot"><span class="annottext">Number -&gt; Number -&gt; Bool
(Number -&gt; Number -&gt; Bool)
-&gt; (Number -&gt; Number -&gt; Bool) -&gt; Eq Number
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: Number -&gt; Number -&gt; Bool
$c/= :: Number -&gt; Number -&gt; Bool
== :: Number -&gt; Number -&gt; Bool
$c== :: Number -&gt; Number -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-54"></span><span>
</span><span id="line-55"></span><span class="hs-comment">-- | Cases are not complete. They will be extended as the application grows</span><span>
</span><span id="line-56"></span><span class="hs-keyword">data</span><span> </span><span id="Case"><span class="annot"><a href="Features.Nominal.html#Case"><span class="hs-identifier hs-var">Case</span></a></span></span><span>
</span><span id="line-57"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="Absolutive"><span class="annot"><a href="Features.Nominal.html#Absolutive"><span class="hs-identifier hs-var">Absolutive</span></a></span></span><span>
</span><span id="line-58"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Ergative"><span class="annot"><a href="Features.Nominal.html#Ergative"><span class="hs-identifier hs-var">Ergative</span></a></span></span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Dative"><span class="annot"><a href="Features.Nominal.html#Dative"><span class="hs-identifier hs-var">Dative</span></a></span></span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Genitive"><span class="annot"><a href="Features.Nominal.html#Genitive"><span class="hs-identifier hs-var">Genitive</span></a></span></span><span> </span><span class="annot"><a href="Features.Nominal.html#Person"><span class="hs-identifier hs-type">Person</span></a></span><span> </span><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier hs-type">Number</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="annot"><a href="Features.Nominal.html#Case"><span class="hs-identifier hs-type">Case</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-61"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081418"><span id="local-6989586621679081420"><span id="local-6989586621679081422"><span class="annot"><span class="annottext">Int -&gt; Case -&gt; ShowS
[Case] -&gt; ShowS
Case -&gt; String
(Int -&gt; Case -&gt; ShowS)
-&gt; (Case -&gt; String) -&gt; ([Case] -&gt; ShowS) -&gt; Show Case
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Case] -&gt; ShowS
$cshowList :: [Case] -&gt; ShowS
show :: Case -&gt; String
$cshow :: Case -&gt; String
showsPrec :: Int -&gt; Case -&gt; ShowS
$cshowsPrec :: Int -&gt; Case -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081414"><span id="local-6989586621679081416"><span class="annot"><span class="annottext">Case -&gt; Case -&gt; Bool
(Case -&gt; Case -&gt; Bool) -&gt; (Case -&gt; Case -&gt; Bool) -&gt; Eq Case
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: Case -&gt; Case -&gt; Bool
$c/= :: Case -&gt; Case -&gt; Bool
== :: Case -&gt; Case -&gt; Bool
$c== :: Case -&gt; Case -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-62"></span><span>
</span><span id="line-63"></span><span class="hs-comment">-- | A noun can have definite determination (default) or indefinite.</span><span>
</span><span id="line-64"></span><span class="hs-comment">--   Additionally, they can be determined through Demonstratives (with a distance degree)</span><span>
</span><span id="line-65"></span><span class="hs-keyword">data</span><span> </span><span id="Determiner"><span class="annot"><a href="Features.Nominal.html#Determiner"><span class="hs-identifier hs-var">Determiner</span></a></span></span><span>
</span><span id="line-66"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="Dem"><span class="annot"><a href="Features.Nominal.html#Dem"><span class="hs-identifier hs-var">Dem</span></a></span></span><span> </span><span class="annot"><a href="Features.Adverbial.html#Distance"><span class="hs-identifier hs-type">Distance</span></a></span><span>
</span><span id="line-67"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Definite"><span class="annot"><a href="Features.Nominal.html#Definite"><span class="hs-identifier hs-var">Definite</span></a></span></span><span>
</span><span id="line-68"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Indefinite"><span class="annot"><a href="Features.Nominal.html#Indefinite"><span class="hs-identifier hs-var">Indefinite</span></a></span></span><span>
</span><span id="line-69"></span><span>  </span><span class="hs-keyword">deriving</span><span>
</span><span id="line-70"></span><span>    </span><span class="hs-special">(</span><span id="local-6989586621679081405"><span id="local-6989586621679081407"><span id="local-6989586621679081409"><span class="annot"><span class="annottext">Int -&gt; Determiner -&gt; ShowS
[Determiner] -&gt; ShowS
Determiner -&gt; String
(Int -&gt; Determiner -&gt; ShowS)
-&gt; (Determiner -&gt; String)
-&gt; ([Determiner] -&gt; ShowS)
-&gt; Show Determiner
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Determiner] -&gt; ShowS
$cshowList :: [Determiner] -&gt; ShowS
show :: Determiner -&gt; String
$cshow :: Determiner -&gt; String
showsPrec :: Int -&gt; Determiner -&gt; ShowS
$cshowsPrec :: Int -&gt; Determiner -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081401"><span id="local-6989586621679081403"><span class="annot"><span class="annottext">Determiner -&gt; Determiner -&gt; Bool
(Determiner -&gt; Determiner -&gt; Bool)
-&gt; (Determiner -&gt; Determiner -&gt; Bool) -&gt; Eq Determiner
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: Determiner -&gt; Determiner -&gt; Bool
$c/= :: Determiner -&gt; Determiner -&gt; Bool
== :: Determiner -&gt; Determiner -&gt; Bool
$c== :: Determiner -&gt; Determiner -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-71"></span><span>
</span><span id="line-72"></span><span class="hs-comment">-- Demonstrative could be a subclass of Definite</span><span>
</span><span id="line-73"></span><span>
</span><span id="line-74"></span><span class="hs-comment">-- | A noun can either be modified by a possessive or not</span><span>
</span><span id="line-75"></span><span class="hs-keyword">data</span><span> </span><span id="Possessive"><span class="annot"><a href="Features.Nominal.html#Possessive"><span class="hs-identifier hs-var">Possessive</span></a></span></span><span>
</span><span id="line-76"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="Poss"><span class="annot"><a href="Features.Nominal.html#Poss"><span class="hs-identifier hs-var">Poss</span></a></span></span><span> </span><span class="annot"><a href="Features.Nominal.html#Person"><span class="hs-identifier hs-type">Person</span></a></span><span> </span><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier hs-type">Number</span></a></span><span>
</span><span id="line-77"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="NoPoss"><span class="annot"><a href="Features.Nominal.html#NoPoss"><span class="hs-identifier hs-var">NoPoss</span></a></span></span><span>
</span><span id="line-78"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081393"><span id="local-6989586621679081395"><span id="local-6989586621679081397"><span class="annot"><span class="annottext">Int -&gt; Possessive -&gt; ShowS
[Possessive] -&gt; ShowS
Possessive -&gt; String
(Int -&gt; Possessive -&gt; ShowS)
-&gt; (Possessive -&gt; String)
-&gt; ([Possessive] -&gt; ShowS)
-&gt; Show Possessive
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Possessive] -&gt; ShowS
$cshowList :: [Possessive] -&gt; ShowS
show :: Possessive -&gt; String
$cshow :: Possessive -&gt; String
showsPrec :: Int -&gt; Possessive -&gt; ShowS
$cshowsPrec :: Int -&gt; Possessive -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081389"><span id="local-6989586621679081391"><span class="annot"><span class="annottext">Possessive -&gt; Possessive -&gt; Bool
(Possessive -&gt; Possessive -&gt; Bool)
-&gt; (Possessive -&gt; Possessive -&gt; Bool) -&gt; Eq Possessive
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: Possessive -&gt; Possessive -&gt; Bool
$c/= :: Possessive -&gt; Possessive -&gt; Bool
== :: Possessive -&gt; Possessive -&gt; Bool
$c== :: Possessive -&gt; Possessive -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-79"></span><span>
</span><span id="line-80"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-81"></span><span class="hs-comment">-- Monoids for Person and Number</span><span>
</span><span id="line-82"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-83"></span><span>
</span><span id="line-84"></span><span class="hs-keyword">instance</span><span> </span><span id="local-6989586621679081384"><span id="local-6989586621679081386"><span class="annot"><span class="hs-identifier hs-type">Semigroup</span></span><span> </span><span class="annot"><a href="Features.Nominal.html#Person"><span class="hs-identifier hs-type">Person</span></a></span></span></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-85"></span><span>  </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#First"><span class="hs-identifier hs-var">First</span></a></span><span> </span><span id="local-6989586621679081382"><span class="annot"><span class="annottext">&lt;&gt; :: Person -&gt; Person -&gt; Person
</span><span class="hs-operator hs-var hs-var hs-var hs-var">&lt;&gt;</span></span></span><span> </span><span class="annot"><span class="annottext">Person
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#First"><span class="hs-identifier hs-var">First</span></a></span><span>
</span><span id="line-86"></span><span>  </span><span class="annot"><span class="annottext">Person
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="hs-operator hs-var">&lt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#First"><span class="hs-identifier hs-var">First</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#First"><span class="hs-identifier hs-var">First</span></a></span><span>
</span><span id="line-87"></span><span>  </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#Second"><span class="hs-identifier hs-var">Second</span></a></span><span> </span><span class="annot"><span class="hs-operator hs-var">&lt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">Person
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#Second"><span class="hs-identifier hs-var">Second</span></a></span><span>
</span><span id="line-88"></span><span>  </span><span class="annot"><span class="annottext">Person
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="hs-operator hs-var">&lt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#Second"><span class="hs-identifier hs-var">Second</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#Second"><span class="hs-identifier hs-var">Second</span></a></span><span>
</span><span id="line-89"></span><span>  </span><span class="annot"><span class="annottext">Person
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="hs-operator hs-var">&lt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">Person
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#Third"><span class="hs-identifier hs-var">Third</span></a></span><span>
</span><span id="line-90"></span><span>
</span><span id="line-91"></span><span class="hs-keyword">instance</span><span> </span><span id="local-6989586621679081376"><span id="local-6989586621679081378"><span class="annot"><span class="hs-identifier hs-type">Monoid</span></span><span> </span><span class="annot"><a href="Features.Nominal.html#Person"><span class="hs-identifier hs-type">Person</span></a></span></span></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-92"></span><span>  </span><span id="local-6989586621679081374"><span class="annot"><span class="annottext">mempty :: Person
</span><span class="hs-identifier hs-var hs-var hs-var hs-var">mempty</span></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="Features.Nominal.html#Third"><span class="hs-identifier hs-var">Third</span></a></span><span>
</span><span id="line-93"></span><span>
</span><span id="line-94"></span><span class="hs-keyword">instance</span><span> </span><span id="local-6989586621679081369"><span id="local-6989586621679081371"><span class="annot"><span class="hs-identifier hs-type">Semigroup</span></span><span> </span><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier hs-type">Number</span></a></span></span></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-95"></span><span>  </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Zero"><span class="hs-identifier hs-var">Zero</span></a></span><span> </span><span id="local-6989586621679081368"><span class="annot"><span class="annottext">&lt;&gt; :: Number -&gt; Number -&gt; Number
</span><span class="hs-operator hs-var hs-var hs-var hs-var">&lt;&gt;</span></span></span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Zero"><span class="hs-identifier hs-var">Zero</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Zero"><span class="hs-identifier hs-var">Zero</span></a></span><span>
</span><span id="line-96"></span><span>  </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Zero"><span class="hs-identifier hs-var">Zero</span></a></span><span> </span><span class="annot"><span class="hs-operator hs-var">&lt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span>
</span><span id="line-97"></span><span>  </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span> </span><span class="annot"><span class="hs-operator hs-var">&lt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Zero"><span class="hs-identifier hs-var">Zero</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span>
</span><span id="line-98"></span><span>  </span><span class="annot"><span class="annottext">Number
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="hs-operator hs-var">&lt;&gt;</span></span><span> </span><span class="annot"><span class="annottext">Number
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Plural"><span class="hs-identifier hs-var">Plural</span></a></span><span>
</span><span id="line-99"></span><span>
</span><span id="line-100"></span><span class="hs-keyword">instance</span><span> </span><span id="local-6989586621679081362"><span id="local-6989586621679081364"><span class="annot"><span class="hs-identifier hs-type">Monoid</span></span><span> </span><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier hs-type">Number</span></a></span></span></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-101"></span><span>  </span><span id="local-6989586621679081361"><span class="annot"><span class="annottext">mempty :: Number
</span><span class="hs-identifier hs-var hs-var hs-var hs-var">mempty</span></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Zero"><span class="hs-identifier hs-var">Zero</span></a></span><span>
</span><span id="line-102"></span></pre></body></html>